#include <stdio.h>
#include <process.h>
#include <windows.h>

#define COUNT 20
int g_Array[COUNT];

CRITICAL_SECTION g_CS;

void WorkProc(void *pData)
{
    volatile int value = *(int *)pData;

    while(1)
    {
        EnterCriticalSection(&g_CS);
    
        for(int i = 0; i < COUNT; i++)
        {
            g_Array[i] = value;
        }
        
        LeaveCriticalSection(&g_CS);
    }
}

int main()
{
    int first  = 1;
    int second = 2;
    
    InitializeCriticalSection(&g_CS);

    _beginthread(WorkProc, 0, &first);
    _beginthread(WorkProc, 0, &second);
    
    while(1)
    {
        EnterCriticalSection(&g_CS);
    
        for(int i = 0; i < COUNT; i++)
        {
            printf("%d ", g_Array[i]);
        }
        
        printf("\n");
        
        LeaveCriticalSection(&g_CS);
        
        Sleep(250);
    }
}

// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
// 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2